	program satcor	
	real wij(100,100),wjk(100,100),xmin(2,100),xmax(2,100)
	real x(100),xmod(2,100),y(100)
*       the file "param.w" contains neural model parameters:
	open(1,file="param.w",status="old")	 
	read(1,*) ii,jj,kk
	do 10 i=1,ii
	  read(1,*) xmax(1,i),xmin(1,i),xmod(1,i)
10	continue
	do 20 i=1,kk
	  read(1,*) xmax(2,i),xmin(2,i),xmod(2,i)
20	continue
       	do 30 i=1,ii+1
	  read(1,*) (wij(i,j),j=1,jj)
30        continue
	do 40 j=1,jj+1
	  read(1,*) (wjk(j,k),k=1,kk)
40        continue
********************Input data**********************
*LIQUID PROPERTIES 
	rol = 1107. 
*density kg/m3
	xmul = .0189
*viscosity kg/m.s
	sigl = .047
*surface tension kg/s2
	ul = .0115             
*superficial velocity m/s

*GAS PROPERTIES
	rog = 3.54
*density kg/m3
	xmug = .0000175   
*viscosity kg/m.s
	ug = .007               
*superficial velocity m/s

*PARTICLE AND BED PROPERTIES
	dv = .00337             
*equivalent grain diameter m
	phi = .91
*sphericity 
	eps = .374
*porosity 
	dc = .023               
*column diameter m
********************************************
	gvl = rol*9.81*dv**2./xmul/ul
	cal = xmul * ul / sigl
	eo = rol * 9.81 / sigl * (dv * phi * eps / (1. - eps))**2.
	xl = ul / ug * (rol / rog)**0.5
	relg = dv * rol * (ul + ug) / xmul
	spsa = 6. * (1. - eps) / phi / dv + 4. / dc
	dh = dv * (16. * eps**3. / 9. / 3.14159 / (1. - eps)**2.)**.3333
	sb = spsa * dh / (1. - eps)
	x(1)= xl
	x(2)=cal
	x(3)=sb
	x(4)=relg
	x(5)=eo
	x(6)=gvl
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y)	
*       liquid saturation prediction is y(1)
	write(6,*) y(1)
	end
	subroutine fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y)
	real wij(100,100),wjk(100,100),xmin(2,100),xmax(2,100)
	real x(100),u(100),h(100),s(100),xmod(2,100),y(100)
*       neural network equations:
	  do 100 i=1,ii
	  if (xmod(1,i).eq.0.) then
	    u(i)=(x(i)-xmin(1,i))/(xmax(1,i)-xmin(1,i))
	  else
	    u(i)=(log10(x(i))-xmin(1,i))/(xmax(1,i)-xmin(1,i))
	  endif
100       continue
	  u(ii+1)=1.
          do 110 j=1,jj
            h(j)=0.
            do 120 i=1,ii+1
120         h(j)=h(j)+wij(i,j)*u(i)
110       h(j)=1./(1.+exp(-h(j)))
          h(jj+1)=1.
          do 130 k=1,kk
            s(k)=0.
            do 140 j=1,jj+1
140         s(k)=s(k)+wjk(j,k)*h(j)
          s(k)=1./(1.+exp(-s(k)))
          y(k)=xmin(2,k)+s(k)*(xmax(2,k)-xmin(2,k))
          if(xmod(2,k).eq.1.) then
            y(k)=10.**(y(k))
          endif
130       continue 
	  return
          end

